﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;

namespace Sample1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            Thread.CurrentThread.CurrentUICulture = CultureInfo.GetCultureInfo("de-DE");
            Thread.CurrentThread.CurrentCulture = CultureInfo.GetCultureInfo("de-DE");

            InitializeComponent();

            series1.ItemsSource = (viewModel.Data[1] as ViewModel2).Data[0];
            series2.ItemsSource = (viewModel.Data[1] as ViewModel2).Data[1];
            series3.ItemsSource = (viewModel.Data[1] as ViewModel2).Data[2];
            series4.ItemsSource = (viewModel.Data[1] as ViewModel2).Data[3];
        }
    }

    public class NumericalAxisExt : NumericalAxis
    {
        List<double> yValues = new List<double>();

        protected override void CalculateVisibleRange(Size avalableSize)
        {
            base.CalculateVisibleRange(avalableSize);

            yValues.Clear();

            SfChart chart = typeof(ChartAxis).GetProperty("Area", System.Reflection.BindingFlags.NonPublic |
                System.Reflection.BindingFlags.Instance).GetValue(this) as SfChart;

            List<double> actualyValues = typeof(XyDataSeries).GetProperty("YValues",
                System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance).GetValue(chart.Series[0]) as List<double>;

            var range = chart.PrimaryAxis.VisibleRange;

            if (actualyValues != null && actualyValues.Count > (int)range.Start && actualyValues.Count > (int)range.End)
            {
                for (int i = (int)range.Start; i <= range.End; i++)
                {
                    yValues.Add(actualyValues[i]);
                }

                if (yValues.Count > 0)
                {
                    double min = yValues.Min();
                    double max = yValues.Max();

                    VisibleRange = new DoubleRange(min, max);
                }
            }
           
           var visibleInterval = CalculateNiceInterval(VisibleRange, avalableSize);

           typeof(ChartAxis).GetProperty("VisibleInterval", System.Reflection.BindingFlags.NonPublic |
                System.Reflection.BindingFlags.Instance).SetValue(this, visibleInterval);
        }
    }

    public class Model
    {
        public DateTime XValue { get; set; }
        public double[] YValue { get; set; }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            Data = new object[] { new ViewModel1(), new ViewModel2() };          
        }

        public object[] Data { get; set; }


    }

    public class ViewModel1
    {
        public ViewModel1()
        {

        }
    }

    public class ViewModel2
    {
        public ViewModel2()
        {
          Data=new ObservableCollection<Model>[]
          {
              GenerateData() ,
              GenerateData(),
              GenerateData(),
              GenerateData()              
          };
        }

        public ObservableCollection<Model> GenerateData()
        {
            var Data = new ObservableCollection<Model>();
            Random rd = new Random();
            int dataCount = 50;
            DateTime dt = new DateTime(2010, 1, 1);

            for (int i = 0; i < dataCount; i++)
            {
                Data.Add(new Model()
                {
                    XValue = dt.AddSeconds(i),
                    YValue = new double[] { 1, 1, 1, 1, 1, 1, rd.Next(0, 50) }
                });
            }

            return Data;
        }

        private ObservableCollection<Model>[] data;

        public ObservableCollection<Model>[] Data
        {
            get { return data; }
            set { data = value; }
        }



    }
}
